// FMBtoOPM v0.01 (c)Ryu Takegami 2023

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "fnamcnv.h"
#include "defs.h"

#define VERSION		"v0.01"
#define DATE		"2023/12/03"

void de_filename2(char *ef,char *df,char *ex)
{
	int i,l,flg;
	char *s;

	i=0;
	s=ef;

	// t@C
	while ((*ef = tolower(*ef)) != '\0') {
		++ef;
	}

	// O(t@C"..\"".\"Jbg)
	strcpy(df,s);
	if (df[0] == '.' && df[1] == '.' && df[2] == '\\' && df[3] != 0) {
		s=&df[3];
	}
	else if (df[0] == '.' && df[1] == '\\' && df[2] != '\0') {
		s=&df[2];
	}
	else {
		s=df;
	}

	// gqǉ
	l = strlen(s);
	if (l < 5 || stricmp(&s[l-5],ex) != 0)
	{
		flg = TRUE;
		for(i = l; i >= 0; i--) {
			if (s[i]=='.') {
				// rŊgq𔭌ꍇ̓sIhȍ~؂̂Ă
				s[i] = '\0';
				break;
			}
			if (s[i]=='\\') {
				// pX̋؂L𔭌ꍇ
				break;
			}
		}

		// gqǉ
		strcat(s,ex);
	}
}

int isSuf(char *name,char *suf)
{
	char *p;

	if( !name || !name[0] ) {
		// 󕶎̏ꍇȂŋA
		return 0;
	}

	// 둤gqr
	name += strlen(name) - 1;
	p = suf + strlen(suf) - 1;

	while( p >= suf ) {
		if ( *name != *p && *name != toupper(*p) ) {
			// 1łI
			return 0;
		}
		name--;
		p--;
	}

	// gqv
	return 1;
}

// ߂
int main(int argc, char **argv)
{
	FILE *fp;
	char path[1024], buf[6152], name[9], *inst, *slot;
	int i, j, k, size;
	static int  slotn[4] = {0, 2, 1, 3};

	// N߂[
	printf("FMB to OPM converter FMBtoOPM "VERSION" ("DATE")\n");
	printf("Copyright (c) Ryu Takegami 2023\n\n");

	// `FbNBȂΎgoďI
	if (argc <= 1) {
		printf("usage : %s <filename.fmb>\n", argv[0]);
		return -1;
	}

	// gqւ EUPt@Cw肳ꂽꍇ̏
	strcpy(path, argv[1]);
	if (isSuf(path, ".eup")) {
		// eupw肳ꂽ̂ł̏ꍇ̏
		memset(buf, 0, 16);
		fp = fopen(path, "rb");
		if (!fp) {
			printf("%s : t@CI[v[\n", path);
			return 2;
		}
		fseek(fp, 0x6e2, SEEK_SET);
		fread(buf, 1, 8, fp);
		fclose(fp);
		printf("%s w肳܂B%s.fmb ǂݍ݂܂B\n", path, buf);
		de_filename2(buf, path, ".fmb");
	}
	else {
		de_filename2(argv[1], path, ".fmb");
	}

	// FMBt@Cǂݍ
	fp = fopen(path, "rb");
	if (!fp) {
		printf("%s : t@CI[v[\n", path);
		return 1;
	}
	fseek(fp, 0, SEEK_END);
	size = ftell(fp);
	fseek(fp, 0, SEEK_SET);
	if (size != 6152) {
		printf("%s : fmbt@C6,152oCgłȂƂȂ܂B\n", path);
		fclose(fp);
		return 1;
	}
	fread(buf, 1, 6152, fp);
	fclose(fp);
	printf("%s ̓ǂݍ݂܂B\n", path);

	// OPMt@C[Ղ
	de_filename2(path, path, ".opm");
	fp = fopen(path, "w+b");
	if (!fp) {
		printf("%s : t@CI[v[\n", path);
		return 1;
	}
	printf("%s ̏oJn܂B\n", path);

	// Ff[^oB܂Ȃ蔲
	for (i = 0; i < 128; i++) {
		inst = &buf[8 + i * 48];
		memset(name, 0, 9);
		strncpy(name, inst, 8);
		fprintf(fp, "@:%d %s\n", i, name);
		fprintf(fp, "LFO: %d %d %d %d %d\n",
			0, 0, 0, 0, 0);	// HW LFO͂ȂɌŒ
		fprintf(fp, "CH: %d %d %d %d %d %d %d\n",
			64, ((inst[32] & 0x38) >> 3), (inst[32] & 7),
			((inst[33] & 0x18) >> 3), (inst[33] & 7), 120, 0);

		for (j = 0; j < 4; j++) {
			slot = &inst[8 + slotn[j]];
			fprintf(fp, "%s%d: %d %d %d %d %d %d %d %d %d %d %d\n",
				(j & 1) ? "C" : "M", ((j & 2) >> 1) + 1,
				slot[8] & 0x1f, slot[12] & 0x1f, slot[16] & 0x1f, slot[20] & 0x0f,
				(slot[20] & 0xf0) >> 4, slot[4], (slot[8] & 0xc0) >> 6, slot[0] & 0x0f,
				(slot[0] & 0x70) >> 4, 0, 0);
		}
	}

	// n
	fclose(fp);
	printf("%s ̏o܂B\n", path);

	// ܂
	return 0;
}
